Index: chan_gtalk.c
===================================================================
--- chan_gtalk.c	(revision 45256)
+++ chan_gtalk.c	(working copy)
@@ -838,8 +838,14 @@
 			buddy = ASTOBJ_CONTAINER_FIND(&client->connection->buddies, them);
 			if (buddy)
 				resources = buddy->resources;
-		} else 
-			resources = client->buddy->resources;
+		} else {
+			if (client->buddy) {
+				resources = client->buddy->resources;
+			} else {
+				ast_log(LOG_ERROR,"no gtalk capable cliets to talk to.\n");
+				return NULL;
+			}
+		}
 		while (resources) {
 			if (resources->cap->jingle) {
 				break;
@@ -880,8 +886,6 @@
 	} else
 		exten = tmp->us;
 	ast_copy_string(tmp->exten,  exten, sizeof(tmp->exten));
-	if(data)
-		free(data);
 	ast_mutex_init(&tmp->lock);
 	ast_mutex_lock(&gtalklock);
 	tmp->next = client->p;
@@ -1658,6 +1662,8 @@
 	struct ast_codec_pref prefs;
 	struct aji_client_container *clients;
 	struct gtalk_candidate *global_candidates = NULL;
+	struct hostent *hp;
+	struct ast_hostent ahp;
 
 	cfg = ast_config_load(GOOGLE_CONFIG);
 	if (!cfg)
@@ -1681,6 +1687,13 @@
 			ast_parse_allow_disallow(&prefs, &global_capability, var->value, 1);
 		else if (!strcasecmp(var->name, "context"))
 			ast_copy_string(context, var->value, sizeof(context));
+		else if (!strcasecmp(var->name, "bindaddr")) {
+			if (!(hp = ast_gethostbyname(var->value, &ahp))) {
+				ast_log(LOG_WARNING, "Invalid address: %s\n", var->value);
+			} else {
+				memcpy(&bindaddr.sin_addr, hp->h_addr, sizeof(bindaddr.sin_addr));
+			}
+		}
 /*  Idea to allow for custom candidates  */
 /*
 		else if (!strcasecmp(var->name, "candidate")) {
